import 'package:bloc/bloc.dart';

String modeString(BackendMode mode) => mode.toString().split('.').last;

BackendMode stringToMode(String string) =>
    string == 'production' ? BackendMode.production : BackendMode.development;

enum BackendMode {
  production,
  development,
}

class BackendSwitcher extends Bloc<SwitcherEvent, String> {
  final String production;
  final String development;

  BackendSwitcher({
    required this.production,
    required this.development,
    BackendMode mode = BackendMode.production,
  }) : super(mode == BackendMode.production ? production : development) {
    on<SwitchProduction>((event, emit) => emit(production));
    on<SwitchDevelopment>((event, emit) => emit(development));
  }

  BackendMode get mode => state == production ? BackendMode.production : BackendMode.development;
}

class SwitchDevelopment extends SwitcherEvent {}

abstract class SwitcherEvent {}

class SwitchProduction extends SwitcherEvent {}
