import 'dart:convert';

class SignedTicket {
  final List<int> nonce;
  final List<int> tag;
  final List<int> ciphertext;

  SignedTicket({required this.nonce, required this.tag, required this.ciphertext});

  factory SignedTicket.fromString(String combined) {
    combined = combined.replaceAll("b'", '');
    combined = combined.replaceAll("'", '');
    final decoded = base64.decode(combined);
    return SignedTicket(
      nonce: decoded.getRange(0, 16).toList(),
      tag: decoded.getRange(16, 32).toList(),
      ciphertext: decoded.getRange(32, decoded.length).toList(),
    );
  }

  List<int> get combined => nonce + tag + ciphertext;

  String get combinedString => base64.encode(combined);

  Map<String, dynamic> get toMap => {
        'nonce': nonce,
        'tag': tag,
        'ciphertext': ciphertext,
      };

  @override
  String toString() => '[SignedTicket $toMap]';
}
